#ifndef METHOD_H_INCLUDED_
#define METHOD_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "function.h"

namespace risc {

class Event;
class Port;

typedef std::vector<Event*> EventVector;
typedef std::vector<Port*> PortVector;

class Method: public Function {

public:

  /**
   * \brief Default constructor
   */
  explicit Method(SgFunctionDefinition *ast_node);

  EventVector static_event_sensitivity_list_;
  PortVector static_port_sensitivity_list_;

  /**
   * \brief Prints the static event list of the method
   */
  void print_event_list();

private:
  /**
   * \brief Disabled copy constructor
   */
  Method(const Method &m);
};

typedef std::vector<Method*> MethodVector;
typedef std::vector<Method*>::iterator MethodVectorIter;
typedef std::vector<Method*>::const_iterator MethodVectorConstIter;

}; // end namespace risc

#endif /* METHOD_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
