#include "search_node_in_namespace.h"

#include "rose_nodes.h"

SgClassDefinition*
risc::tools::find_class_definition(
    std::string class_name,
    std::string qualified_namespace)
{
  // First we try to fiend the native class definition
  std::string class_with_qualifier = qualified_namespace + class_name;

  const std::vector<SgNode*> &class_definitions = RoseNodes::get_class_defs();

  for(std::vector<SgNode*>::const_iterator
      iter  = class_definitions.begin();
      iter != class_definitions.end();
      iter++) {

    SgClassDefinition* current_class = isSgClassDefinition(*iter);

    std::string complete_class_namespace = current_class->get_qualified_name();

    if(!complete_class_namespace.compare(class_with_qualifier)){
      return current_class;
    }
  }

  return NULL;
}

SgTypedefDeclaration* risc::tools::find_typedef_declaration(
    std::string class_name,
    std::string qualified_namespace)
{
  std::string class_with_qualifier = qualified_namespace + class_name;

  const std::vector<SgNode*> &typedef_decls = RoseNodes::get_typedef_decl();

  for(std::vector<SgNode*>::const_iterator
      iter  = typedef_decls.begin();
      iter != typedef_decls.end();
      iter++) {

    SgTypedefDeclaration *type_decl = isSgTypedefDeclaration(*iter);

    std::string complete_class_namespace = type_decl->get_qualified_name();

    if(!complete_class_namespace.compare(class_with_qualifier)) {
      return type_decl;
    }
  }

  return NULL;
}


/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
