#include "systemc.h"

//// Data structures ///////////////////////////////////////////////////////

//typedef struct Coordinates
//{
//  float_t l;  // left bound, e.g. -2.5
//  float_t r;  // right bound, e.g. 1.0
//  float_t b;  // bottom bound, e.g. -1.0
//  float_t t;  // top bound, e.g. 1.0
//
//  friend ostream& operator<<(ostream& os, const Coordinates& co);
//} COORDS;
//
//ostream& operator<<(ostream& os, const Coordinates& co)
//{
//  os << co.l << ' ' << co.r << ' ' << co.b << ' ' << co.t << '\n';
//  return os;
//}
//
//
//// Channels //////////////////////////////////////////////////////////////
//
//class i_coords_sender: virtual public sc_interface
//{
//public:
//  virtual void write(COORDS&) = 0;
//};
//
//class i_coords_receiver: virtual public sc_interface
//{
//public:
//  virtual COORDS read() = 0;
//
//  virtual void read(COORDS&) = 0;
//};
//
//class c_coords_channel: public sc_channel, public i_coords_sender, public i_coords_receiver
//{
//public:
//  c_coords_channel(sc_module_name name, int size_ = 4): sc_channel(name)
//  {
//    size = size_;
//    buf = new COORDS[size];
//    reset();
//  }
//
//  ~c_coords_channel()
//  {
//    delete [] buf;
//  }
//
//  int num_available() const
//  {
//    return size - free_slots;
//  }
//
//  int num_free() const
//  {
//    return free_slots;
//  }
//
//  void write(COORDS& X)
//  {
//    if(num_free() == 0)
//      wait(data_read_event);
//    buf[wi] = X;
//    wi = (wi+1) % size;
//    free_slots --;
//    data_written_event.notify(SC_ZERO_TIME);
//  }
//
//  COORDS read()
//  {
//    if(num_available() == 0)
//      wait(data_written_event);
//    COORDS result = buf[ri];
//    ri = (ri+1) % size;
//    free_slots ++;
//    data_read_event.notify(SC_ZERO_TIME);
//
//    return result;
//  }
//
//  void read(COORDS &coord)
//  {
//    if(num_available() == 0)
//      wait(data_written_event);
//    coord = buf[ri];
//    ri = (ri+1) % size;
//    free_slots ++;
//    data_read_event.notify(SC_ZERO_TIME);
//  }
//
//  void reset()
//  {
//    free_slots = size;
//    ri = 0;
//    wi = 0;
//  }
//
//private:
//  int size;       // size
//  COORDS *buf;    // circular buffer
//  int free_slots; // free space
//  int ri;         // read index
//  int wi;         // write index
//
//  sc_event data_read_event;
//  sc_event data_written_event;
//};

// Modules /////////////////////////////////////////////////////////////

//class ConflictSameVariableDifferentChannel: public sc_module {
//
//  SC_HAS_PROCESS(ConflictSameVariableDifferentChannel);
//
//public:
//
//  sc_port<i_coords_sender> port_out_channel_1;
//  sc_port<i_coords_sender> port_out_channel_2;
//  sc_port<i_coords_receiver> port_in_channel_1;
//  sc_port<i_coords_receiver> port_in_channel_2;
//
//  c_coords_channel channel1;
//  c_coords_channel channel2;
//  COORDS temp;
//
//  ConflictSameVariableDifferentChannel(sc_module_name mn):
//    sc_module(mn),
//    channel1("channel1"),
//    channel2("channel2")
//  {
//    SC_THREAD(thread1);
//    SC_THREAD(thread2);
//  }
//
//  // there is a conflict because they have different channels
//  void thread1()
//  {
//    port_in_channel_1->read(temp);
//  }
//
//  void thread2()
//  {
//    port_in_channel_2->read(temp);
//  }
//
//  void before_end_of_elaboration()
//  {
//    port_out_channel_1.bind(channel1);
//    port_out_channel_2.bind(channel2);
//    port_in_channel_1.bind(channel1);
//    port_in_channel_2.bind(channel2);
//  }
//};
//
//class NoConflictLocalVariableDifferentChannel: public sc_module {
//
//  SC_HAS_PROCESS(NoConflictLocalVariableDifferentChannel);
//
//public:
//  sc_port<i_coords_sender> port_out_channel;
//  sc_port<i_coords_receiver> port_in_channel;
//
//  c_coords_channel channel;
//
//  NoConflictLocalVariableDifferentChannel(sc_module_name mn):
//    sc_module(mn),
//    channel("channel")
//  {
//    SC_THREAD(thread1);
//    SC_THREAD(thread2);
//  }
//
//  // there is a conflict because they have different channels
//  void thread1()
//  {
//    COORDS temp;
//    port_in_channel->read(temp);
//  }
//
//  void thread2()
//  {
//    COORDS temp;
//    port_in_channel->read(temp);
//  }
//
//  void before_end_of_elaboration()
//  {
//    port_out_channel.bind(channel);
//    port_in_channel.bind(channel);
//  }
//};
//
//class NoConflictChannelLock: public sc_module {
//
//  SC_HAS_PROCESS(NoConflictChannelLock);
//
//public:
//
//  c_coords_channel channel;
//  COORDS temp;
//
//  sc_port<i_coords_sender> port_out_channel;
//  sc_port<i_coords_receiver> port_in_channel;
//
//  NoConflictChannelLock(sc_module_name mn):
//    sc_module(mn),
//    channel("channel")
//  {
//    SC_THREAD(thread1);
//    SC_THREAD(thread2);
//  }
//
//  // no conflict because the channels are protected through locks
//  void thread1()
//  {
//    port_in_channel->read(temp);
//  }
//
//  void thread2()
//  {
//    port_in_channel->read(temp);
//  }
//
//  void before_end_of_elaboration()
//  {
//    port_out_channel.bind(channel);
//    port_in_channel.bind(channel);
//  }
//};

class FifoTest: public sc_module {

  SC_HAS_PROCESS(FifoTest);

public:

  sc_fifo<int> fifo1;
  sc_fifo_in<int> fifo_in_1;
  sc_fifo_out<int> fifo_out_1;

  sc_fifo<int> fifo2;
  sc_fifo_in<int> fifo_in_2;
  sc_fifo_out<int> fifo_out_2;

  FifoTest(sc_module_name mn):
    sc_module(mn)
  {
    //SC_THREAD(thread1);
    //SC_THREAD(thread2);

    //SC_THREAD(thread3);
    //SC_THREAD(thread4);

    SC_THREAD(thread5);
    SC_THREAD(thread6);
    SC_THREAD(thread7);
  }

  void before_end_of_elaboration()
  {
    fifo_in_1.bind(fifo1);
    fifo_out_1.bind(fifo1);

    fifo_in_2.bind(fifo2);
    fifo_out_2.bind(fifo2);
  }
  int one, two, three, four;

  void thread1()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int bb;
    int i;
    i = fifo_in_1.read();
    one++;

    wait(SC_ZERO_TIME);
    int cc;

  }

  void thread2()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int i;
    fifo_out_1.write(i);
    two++;

    wait(SC_ZERO_TIME);
    int cc;
  }


  void thread3()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int bb;
    int i;
    i = fifo_in_2.read();
    three++;

    wait(SC_ZERO_TIME);
    int cc;

  }

  void thread4()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int i;
    fifo_out_2.write(i);
    four++;

    wait(SC_ZERO_TIME);
    int cc;
  }

  void thread5()
  {
    //int i = fifo_in_2.read();
  }

  void thread6()
  {
    int i;
    i  = fifo_in_2.read();
  }

  void thread7()
  {
    int i;
    fifo_out_2.write(i);
  }
};

class Top: public sc_module {

  SC_HAS_PROCESS(Top);

public:

  //ConflictSameVariableDifferentChannel csvdc; // works
  //ConflictSameVariableDifferentChannel csvdc1; // works csvdc and csvdc1 are
  //                                             // not conflicting each other
  //NoConflictLocalVariableDifferentChannel nclvdc; // works
  //NoConflictChannelLock nccl; // doesn't work, This is a FALSE POSITIVE
  //                            // However, this is what we expected
  FifoTest ft;

  Top(sc_module_name mn):
    sc_module(mn),
    //csvdc("csvdc")
    //csvdc1("csvdc1"),
    //nclvdc("nclvdc"),
    //nccl("nccl"),
    ft("FifoTest")
  {
    //SC_THREAD(thread1); // works, 'in conflict with all' because function call
    //SC_THREAD(thread2); // takes an argument as reference

    //SC_THREAD(thread3); // works, thread3 and thread4 are not in a conflict
    //SC_THREAD(thread4);

    //SC_THREAD(thread5); // works, thread5 and thread6 are in a conflict
    //SC_THREAD(thread6); // so, we are analyzing the function paramter
    //                    // also if they are nested

    //SC_THREAD(thread7); // this one tests the function paramter analysis
    //                    // for each function call there should be a temp
    //                    // variable
    //                    // works

    //SC_THREAD(thread8); // the declaration in the function must be decomposed
    //                    // because there is a function with a wait

    //SC_THREAD(thread9); // the declaration in the function must be decomposed

    //SC_THREAD(thread10); // should be decomposed because we have also a member
    //                     // access
    //                     // works

    //SC_THREAD(thread11);
  }

  // this is for thread1 and thread2
  int a;
  int b;

  void foo(int &x)
  { }

  void thread1()
  {
    foo(a);
  }

  void thread2()
  {
    a++;
  }
  ////////////////////////////////////////////////////////////

  // this is for thread3 and thread4
  // this on should test the function parameters
  // three should no conflict between the segments of thread3 and thread4

  int conflict1;
  int conflict2;
  void foo2(int z)
  { }

  void thread3()
  {
    int l;
    foo2(5 + conflict2);
  }

  void thread4()
  {
    conflict1++;
  }
  ////////////////////////////////////////////////////////////

  // this is for thread5 and thread6
  // this on should test the function parameters
  // three should no conflict between the segments of thread5 and thread6

  int conflict3;
  int conflict4;
  void foo3(int z)
  { }

  void thread5()
  {
    int l;
    foo3(conflict3 + conflict4);
  }

  void thread6()
  {
    conflict4++;
  }
  ////////////////////////////////////////////////////////////

  void thread7()
  {
    func0(func1(), func2(), func3());
  }

  void func0(int i, int j, int k)
  { }

  int func1()
  {
    wait(SC_ZERO_TIME);
    return 0;
  }

  int func2()
  {
    wait(SC_ZERO_TIME);
    return 0;
  }

  int func3()
  {
    wait(SC_ZERO_TIME);
    return 0;
  }
  ////////////////////////////////////////////////////////////

  void thread8()
  {
    int i = func1();
  }

  void thread9()
  {
    int i = func1() + func2();
  }

  int member;
  void thread10()
  {
    int i = member + func1();
  }
  ////////////////////////////////////////////////////////////

  void thread11()
  {
    wait(SC_ZERO_TIME);
    int a;
    func4();
    int b;
    wait(SC_ZERO_TIME);
  }

  void func4()
  {
    while(3<3) {

      wait(SC_ZERO_TIME);
    }
  }
};

int sc_main(int argc, char **argv)
{
  Top t("top");
  sc_start();

  return 0;
}
