#include "systemc.h"

class Foo: public sc_module {
public:

  sc_in_clk c1;

  void D() { }
  void Y() { D(); D();}
  void X() { Y(); }
  void C() { D(); X(); }
  void B() { C(); }
  void S() { D(); }
  void P() { S(); }
  void O() { P(); }
  void N() { O(); }
  void M() { N(); }
  void G() { M(); }
  void A() { B(); G(); }
  void NO_CALL();


  void after_wait_call() {};
  void another_after_wait_call() {}

  SC_HAS_PROCESS(Foo);

  Foo(sc_module_name mn):
    sc_module(mn)
  {

    SC_CTHREAD(my_cthread1, c1.pos());
    SC_CTHREAD(my_cthread2, c1.neg());
    SC_CTHREAD(my_cthread3, c1.pos());
    SC_CTHREAD(my_cthread4, c1.neg());
    SC_CTHREAD(my_cthread5, c1.neg());

  }

  void my_cthread1()
  {
    wait();
  }

  void my_cthread2()
  {
    S (); // S, D
    wait();
  }

  void my_cthread3()
  {
    M(); // M N O P S D
    NO_CALL();

    wait();

    after_wait_call();
    another_after_wait_call();
  }

  void my_cthread4()
  {
    D(); // D
    wait();
    after_wait_call();
  }

  void my_cthread5()
  {
    B(); // B C X Y D
    O(); // O P S D
    wait();
  }
};


int sc_main(int argc, char* argv[])
{

  Foo foo("foo");

  sc_start(100, SC_NS);


  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
